package com.fjhx.victoriatourist.service;

import cn.hutool.extra.spring.SpringUtil;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.toolkit.ObjectUtils;
import com.fjhx.purchase.entity.purchase.po.Purchase;
import com.fjhx.purchase.entity.sales.po.SalesReturn;
import com.fjhx.purchase.entity.sales.po.SalesReturnDetail;
import com.fjhx.purchase.service.purchase.PurchaseService;
import com.fjhx.purchase.service.WdlySalesReturnService;
import com.fjhx.victoriatourist.entity.order.po.OrderDetails;
import com.fjhx.victoriatourist.entity.order.po.OrderInfo;
import com.fjhx.victoriatourist.service.order.OrderDetailsService;
import com.fjhx.victoriatourist.service.order.OrderInfoService;
import com.obs.services.internal.ServiceException;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

public class WdlySalesReturnServiceImpl implements WdlySalesReturnService {
    @Override
    public void startByWdly(SalesReturn salesReturn) {
        //判断是否存在维多利亚数据存在就处理
        if (ObjectUtils.isEmpty(salesReturn.getVictoriatouristJson())) {
            return;
        }
        PurchaseService purchaseService = SpringUtil.getBean(PurchaseService.class);
        OrderInfoService orderInfoService = SpringUtil.getBean(OrderInfoService.class);
        OrderDetailsService orderDetailsService = SpringUtil.getBean(OrderDetailsService.class);

        //查询采购订单信息
        String victoriatouristJson = salesReturn.getVictoriatouristJson();
        JSONObject json = JSONObject.parseObject(victoriatouristJson);
        Purchase purchase = purchaseService.getById(json.getLong("purchaseId"));
        //创建退货订单
        OrderInfo orderInfo = new OrderInfo();
        orderInfo.setType(7);
        orderInfo.setCode(purchase.getCode());
        orderInfo.setStatus(1);
        orderInfo.setIssueStatus(1);
        orderInfo.setContacts(json.getString("contacts"));//收件人
        orderInfo.setPhone(json.getString("phone"));//联系电话
        orderInfo.setCityId(json.getString("cityId"));//所在市
        orderInfo.setProvinceId(json.getString("provinceId"));//所在省
        orderInfo.setCountryId(json.getString("countryId"));//所在国家
        orderInfo.setDetailedAddress(json.getString("detailedAddress"));//详细地址
        orderInfoService.save(orderInfo);
        //创建订单明细
        List<OrderDetails> orderDetailsList = new ArrayList<>();
        for (SalesReturnDetail salesReturnDetail : salesReturn.getSalesReturnDetailList()) {
            String victoriatouristJson1 = salesReturnDetail.getVictoriatouristJson();
            if (ObjectUtils.isEmpty(victoriatouristJson1)) {
                throw new ServiceException("物品单价不能为空");
            }
            JSONObject json1 = JSONObject.parseObject(victoriatouristJson);
            //忽略退货数量为0或小于0的物品
            if (salesReturnDetail.getCount().compareTo(BigDecimal.ZERO) > 0) {
                OrderDetails orderDetails = new OrderDetails();
                orderDetails.setOrderId(orderInfo.getId());
                orderDetails.setProductId(salesReturnDetail.getBussinessId());
                orderDetails.setQuantity(salesReturnDetail.getCount());
                orderDetails.setPrice(json1.getBigDecimal("unitPrice"));
                orderDetails.setNotIssuedQuantity(salesReturnDetail.getCount());
                orderDetailsList.add(orderDetails);
            }
        }
        orderDetailsService.saveBatch(orderDetailsList);
    }
}
